Unit FileIO;

(****************************************************************************
**                                                                         **
**  Data File input and output routines.                                   **
**                                                                         **
****************************************************************************)

Interface

Const

  { type of data files }
  SurfData    =  0;    { raw data type }
  SurfImage   =  1;    { custom image format }
  SurfView    =  2;    { surface data + viewpoint, color, etc. }
  SurfUnused3 =  3;    { unused }
  SurfUnused4 =  4;    { unused }
  SurfUnused5 =  5;    { unused }
  SurfUnused6 =  6;    { unused }
  SurfUnused7 =  7;    { unused }
  SurfUnused8 =  8;    { unused }
  SurfUnused9 =  9;    { PCX image file }
  SurfGIF     = 10;    { GIF image file }

  { file operations }
  None        = -1;
  Load        = 0;
  Save        = 1;

  { search names for file formats }
  FileIDNames : Array[SurfData..SurfGIF] of String[5] =
    ('DATA','IMAGE','VIEW','','','','','','','','GIF');

  { type of file to use for saving and loading and surrent operation }
  FileType     : Integer = None;
  FileOper     : Integer = None;

  { name of data file }
  DataFileName : String = '';

Procedure CheckFile(Path : String);
Procedure DoLoadFile(FileType : Integer; Path : String);
Procedure DoSaveFile(FileType : Integer; Path : String);

Implementation

Uses
  FDecls,     { standard declarations }
  DOS,        { obscure file manipulation gadgets }
  Graph,      { graphics color and deice constants }
  Graphics,   { other graphics routines }
  GridFunc;   { grid maintainance routines }

{---------------------------------------------------------------------------}

Procedure Open(Path : String; Var DataFile : File; FileOper : Integer);
{
  Open data file.  Aborts if unable to correctly open file
}
Var
  ErrCode : Integer;
Begin

  { associate name with file }
  Assign(DataFile,Path);

  { open file }
  {$I-}
  Case FileOper of
    Load : Reset(DataFile);
    Save : Rewrite(DataFile);
    Else
      Abort('Unknown file operation in procedure Open')
  End; { Case }
  {$I+}

  { check system's error }
  ErrCode := IOResult;

  { bomb if error }
  If ErrCode <> 0 then
    Abort('Error opening file ' + Path + ' code = ' + Int2Str(ErrCode))

End; { Procedure Open }

{---------------------------------------------------------------------------}

Procedure CheckFile;
{
  Check file header.
}
Begin


End; { Procedure CheckFile }

{---------------------------------------------------------------------------}

Procedure DoLoadFile(FileType : Integer; Path : String);
{
  load file
}
Begin


End; { Procedure DoLoadFile }

{---------------------------------------------------------------------------}

Procedure DoSaveFile(FileType : Integer; Path : String);
{
  Save file
}
Begin

End; { Procedure DoSaveFile }

{---------------------------------------------------------------------------}

End. { Unit FileIO }
