Unit Timer;

(****************************************************************************
**                                                                         **
**  Simple timer routines.                                                 **
**                                                                         **
****************************************************************************)

Interface

Uses
  Vectors;

Var
  TimerTicks : LongInt;

Procedure TimerStart;
Function TimerEnd : LongInt;
Function Ticks2Secs(N : LongInt) : Float;

Implementation

Uses
  DOS;

{---------------------------------------------------------------------------}

Procedure TimerStart;
{
  Start timer (get current time into TimerTicks)
}
Var
  R : Registers;
Begin

  With R do begin

    AH := 0;
    Intr($1A,R);

    TimerTicks := CX shl 16 + DX

  End { With }

End; { Procedure TimerStart }

{---------------------------------------------------------------------------}

Function TimerEnd;
{
  Set TimerTicks to ticks elapsed since call to TimerStart
}
Var
  R : Registers;
Begin

  With R do begin

    AH := 0;
    Intr($1A,R);

    TimerTicks := (CX shl 16 + DX) - TimerTicks

  End; { With }

  TimerEnd := TimerTicks

End; { Function TimerEnd }

{---------------------------------------------------------------------------}

Function Ticks2Secs;
{
  Convert ticks to seconds
}
Begin
  Ticks2Secs := N / 18.2065
End; { Function Ticks2Secs }

{---------------------------------------------------------------------------}

End. { Unit Timer }